// Generated by gtkmmproc -- DO NOT MODIFY!


#include <libnotifymm/notification.h>
#include <libnotifymm/private/notification_p.h>

// -*- C++ -*- // 

/* notification.ccg
 * 
 * Copyright 2006 libnotifymm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include <libnotify/notification.h>
#include <libnotify/notify-enum-types.h>

namespace Notify
{

const int EXPIRES_DEFAULT = NOTIFY_EXPIRES_DEFAULT;
const int EXPIRES_NEVER = NOTIFY_EXPIRES_NEVER;

Notification::Notification(const Glib::ustring& summary, const Glib::ustring& body) :
	// Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(notification_class_.init(), "summary",summary.c_str(),"body",body.c_str(),"icon-name",NULL,"attach-widget",NULL, static_cast<char*>(0)))
{
	
}
	
Notification::Notification(const Glib::ustring& summary, const Glib::ustring& body,
													 const Glib::ustring& icon_name) :
	// Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(notification_class_.init(), "summary",summary.c_str(),"body",body.c_str(),"icon-name",icon_name.c_str(),"attach-widget",NULL, static_cast<char*>(0)))
{
	
}

void Notification::set_hint(const Glib::ustring& key, const Glib::ArrayHandle<guchar>& values)
{
	notify_notification_set_hint_byte_array (gobj(), key.c_str(), values.data(), values.size());
}

//We use a function instead of a static method, so we can make it static, so it is not exported.
static void SignalProxy_ActivateLink_gtk_callback(NotifyNotification* notify, gchar* action, gpointer data)
{
  Notify::Notification::SlotInvokeAction* the_slot = static_cast<Notify::Notification::SlotInvokeAction*>(data);

  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  try
  {
  #endif //GLIBMM_EXCEPTIONS_ENABLED
    (*the_slot)(Glib::convert_const_gchar_ptr_to_ustring(action) );
  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
  #endif //GLIBMM_EXCEPTIONS_ENABLED
}

static void SignalProxy_ActivateLink_gtk_callback_destroy(void* data)
{
  Notify::Notification::SlotInvokeAction* the_slot = static_cast<Notify::Notification::SlotInvokeAction*>(data);
  delete the_slot;
}

void Notification::add_action(const Glib::ustring& action, const Glib::ustring& label, const SlotInvokeAction& slot)
{
	// Create a copy of the slot object. A pointer to this will be passed
  // through the callback's data parameter.  It will be deleted
  // when SignalProxy_SlotForwardPage_gtk_callback_destroy() is called.
  SlotInvokeAction* slot_copy = new SlotInvokeAction(slot);

  notify_notification_add_action(gobj(), action.c_str(), label.c_str(),
      &SignalProxy_ActivateLink_gtk_callback, slot_copy,
      &SignalProxy_ActivateLink_gtk_callback_destroy);
}

} // namespace Notify
 

namespace
{


static void Notification_signal_closed_callback(NotifyNotification* self, gint p0,void* data)
{
  using namespace Notify;
  typedef sigc::slot< void,gint > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(p0);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo Notification_signal_closed_info =
{
  "closed",
  (GCallback) &Notification_signal_closed_callback,
  (GCallback) &Notification_signal_closed_callback
};


} // anonymous namespace

// static
GType Glib::Value<Notify::Urgency>::value_type()
{
  return notify_urgency_get_type();
}


namespace Glib
{

Glib::RefPtr<Notify::Notification> wrap(NotifyNotification* object, bool take_copy)
{
  return Glib::RefPtr<Notify::Notification>( dynamic_cast<Notify::Notification*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Notify
{


/* The *_Class implementation: */

const Glib::Class& Notification_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Notification_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(notify_notification_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}

void Notification_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  klass->closed = &closed_callback;
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void Notification_Class::closed_callback(NotifyNotification* self, gint p0)
{
  Glib::ObjectBase *const obj_base = static_cast<Glib::ObjectBase*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj_base && obj_base->is_derived_())
  {
    CppObjectType *const obj = dynamic_cast<CppObjectType* const>(obj_base);
    if(obj) // This can be NULL during destruction.
    {
      #ifdef GLIBMM_EXCEPTIONS_ENABLED
      try // Trap C++ exceptions which would normally be lost because this is a C callback.
      {
      #endif //GLIBMM_EXCEPTIONS_ENABLED
        // Call the virtual member method, which derived classes might override.
        obj->on_closed(p0);
        return;
      #ifdef GLIBMM_EXCEPTIONS_ENABLED
      }
      catch(...)
      {
        Glib::exception_handlers_invoke();
      }
      #endif //GLIBMM_EXCEPTIONS_ENABLED
    }
  }
  
  BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

  // Call the original underlying C function:
  if(base && base->closed)
    (*base->closed)(self, p0);
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* Notification_Class::wrap_new(GObject* object)
{
  return new Notification((NotifyNotification*)object);
}


/* The implementation: */

NotifyNotification* Notification::gobj_copy()
{
  reference();
  return gobj();
}

Notification::Notification(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

Notification::Notification(NotifyNotification* castitem)
:
  Glib::Object((GObject*)(castitem))
{}

Notification::~Notification()
{}


Notification::CppClassType Notification::notification_class_; // initialize static member

GType Notification::get_type()
{
  return notification_class_.init().get_type();
}

GType Notification::get_base_type()
{
  return notify_notification_get_type();
}


Notification::Notification(const Glib::ustring& summary, const Glib::ustring& body, const Glib::ustring& icon_name, Gtk::Widget& attach_widget)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(notification_class_.init(), "summary", summary.c_str(), "body", body.c_str(), "icon_name", icon_name.c_str(), "attach_widget", (attach_widget).gobj(), static_cast<char*>(0)))
{
  

}

Notification::Notification(const Glib::ustring& summary, const Glib::ustring& body, const Glib::ustring& icon_name, const Glib::RefPtr<Gtk::StatusIcon>& status_icon)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(notification_class_.init(), "summary", summary.c_str(), "body", body.c_str(), "icon_name", icon_name.c_str(), "status_icon", Glib::unwrap(status_icon), static_cast<char*>(0)))
{
  

}

bool Notification::update(const Glib::ustring& summary, const Glib::ustring& body, const Glib::ustring& icon)
{
  return notify_notification_update(gobj(), summary.c_str(), body.c_str(), icon.c_str());
}

void Notification::attach_to_widget(Gtk::Widget& attach)
{
notify_notification_attach_to_widget(gobj(), (attach).gobj()); 
}

void Notification::attach_to_status_icon(const Glib::RefPtr<Gtk::StatusIcon>& status_icon)
{
notify_notification_attach_to_status_icon(gobj(), Glib::unwrap(status_icon)); 
}

void Notification::set_geometry_hints(const Glib::RefPtr<Gdk::Screen>& screen, int x, int y)
{
notify_notification_set_geometry_hints(gobj(), Glib::unwrap(screen), x, y); 
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
bool Notification::show()
#else
bool Notification::show(std::auto_ptr<Glib::Error>& error)
#endif //GLIBMM_EXCEPTIONS_ENABLED
{
  GError* gerror = 0;
  bool retvalue = notify_notification_show(gobj(), &(gerror));
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
#else
  if(gerror)
    error = ::Glib::Error::throw_exception(gerror);
#endif //GLIBMM_EXCEPTIONS_ENABLED

  return retvalue;

}

void Notification::set_timeout(int timeout)
{
notify_notification_set_timeout(gobj(), timeout); 
}

void Notification::set_category(const Glib::ustring& category)
{
notify_notification_set_category(gobj(), category.c_str()); 
}

void Notification::set_urgency(Urgency urgency)
{
notify_notification_set_urgency(gobj(), ((NotifyUrgency)(urgency))); 
}

void Notification::set_icon_from_pixbuf(const Glib::RefPtr<Gdk::Pixbuf>& icon)
{
notify_notification_set_icon_from_pixbuf(gobj(), Glib::unwrap(icon)); 
}

void Notification::set_hint(const Glib::ustring& key, int value)
{
notify_notification_set_hint_int32(gobj(), key.c_str(), value); 
}

void Notification::set_hint(const Glib::ustring& key, double value)
{
notify_notification_set_hint_double(gobj(), key.c_str(), value); 
}

void Notification::set_hint(const Glib::ustring& key, const Glib::ustring& value)
{
notify_notification_set_hint_string(gobj(), key.c_str(), value.c_str()); 
}

void Notification::set_hint(const Glib::ustring& key, guchar value)
{
notify_notification_set_hint_byte(gobj(), key.c_str(), value); 
}

void Notification::clear_hints()
{
notify_notification_clear_hints(gobj()); 
}

void Notification::clear_actions()
{
notify_notification_clear_actions(gobj()); 
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
void Notification::close()
#else
void Notification::close(std::auto_ptr<Glib::Error>& error)
#endif //GLIBMM_EXCEPTIONS_ENABLED
{
  GError* gerror = 0;
  notify_notification_close(gobj(), &(gerror));
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
#else
  if(gerror)
    error = ::Glib::Error::throw_exception(gerror);
#endif //GLIBMM_EXCEPTIONS_ENABLED


}


Glib::SignalProxy1< void,gint > Notification::signal_closed()
{
  return Glib::SignalProxy1< void,gint >(this, &Notification_signal_closed_info);
}


#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy<Glib::ustring> Notification::property_summary() 
{
  return Glib::PropertyProxy<Glib::ustring>(this, "summary");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly<Glib::ustring> Notification::property_summary() const
{
  return Glib::PropertyProxy_ReadOnly<Glib::ustring>(this, "summary");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy<Glib::ustring> Notification::property_body() 
{
  return Glib::PropertyProxy<Glib::ustring>(this, "body");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly<Glib::ustring> Notification::property_body() const
{
  return Glib::PropertyProxy_ReadOnly<Glib::ustring>(this, "body");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy<Glib::ustring> Notification::property_icon_name() 
{
  return Glib::PropertyProxy<Glib::ustring>(this, "icon-name");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly<Glib::ustring> Notification::property_icon_name() const
{
  return Glib::PropertyProxy_ReadOnly<Glib::ustring>(this, "icon-name");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy<Gtk::Widget> Notification::property_attach_widget() 
{
  return Glib::PropertyProxy<Gtk::Widget>(this, "attach-widget");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly<Gtk::Widget> Notification::property_attach_widget() const
{
  return Glib::PropertyProxy_ReadOnly<Gtk::Widget>(this, "attach-widget");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy< Glib::RefPtr<Gtk::StatusIcon> > Notification::property_status_icon() 
{
  return Glib::PropertyProxy< Glib::RefPtr<Gtk::StatusIcon> >(this, "status-icon");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gtk::StatusIcon> > Notification::property_status_icon() const
{
  return Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gtk::StatusIcon> >(this, "status-icon");
}
#endif //GLIBMM_PROPERTIES_ENABLED


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void Notify::Notification::on_closed(gint reason)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->closed)
    (*base->closed)(gobj(),reason);
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Notify


